REM
REM  This file is part of the zBoy project
REM  Copyright (C) Mateusz Viste 2010, 2011
REM
REM  Provides GetSaveDir() - feeding a variable called
REM  SaveDir, that contain the directory in which zBoy
REM  has to store its various save files.
REM

#MACRO GetSaveDir()
  DIM AS STRING SaveDir
  #IFDEF __FB_LINUX__
    SaveDir = ENVIRON("HOME") & "/.zboy/"
  #ENDIF
  #IFDEF __FB_WIN32__
    IF (LEN(ENVIRON("USERPROFILE")) > 0) THEN
        SaveDir = ENVIRON("USERPROFILE") & "\zboy_sav\"
      ELSE
        SaveDir = EXEPATH() & "\battmem\"
    END IF
  #ENDIF
  #IFDEF __FB_DOS__
    SaveDir = EXEPATH() & "\battmem\"
  #ENDIF
#ENDMACRO
