REM
REM This file is part of the zBoy project.
REM Copyright (C) Mateusz Viste 2010, 2011
REM

#DEFINE SaveScoresFile (SaveDir & HEX(RomInfos.CRCsum, 8) & ".hi")
DIM SHARED SaveScoresWriteProtection(1 TO 32) AS UINTEGER => {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}

SUB SaveHiScoresMem()
  'DIM AS UBYTE UbyteBuff1, UbyteBuff2
  DIM AS UINTEGER FileHandler, UintVar
  FileHandler = FREEFILE
  GetSaveDir()  ' provides the SaveDir variable
  SELECT CASE RomInfos.CrcSum
    CASE &h0509069C, &hB681E243  ' Pac-Man
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hFF8C TO &hFF8E
        PUT #FileHandler,, MemoryInternalHiRAM(UintVar)
        SaveScoresWriteProtection(UintVar - &hFF89) = UintVar
      NEXT UintVar
      CLOSE FileHandler
    CASE &hF59CEDEA  ' Pipe Dream
        OPEN SaveScoresFile FOR OUTPUT AS FileHandler
        FOR UintVar = &hC212 TO &hC22C
          PUT #FileHandler,, MemoryInternalRAM(UintVar)
        NEXT UintVar
        CLOSE FileHandler
    CASE &h2C27EC70, &h90776841  ' Super Marioland v1.1 and Super Marioland v1.0
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      'FOR UintVar = &hC0A0 TO &hC0A3
      '  PUT #FileHandler,, MemoryInternalRAM(UintVar)
      'NEXT UintVar
      FOR UintVar = &hC0C0 TO &hC0C3
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
      NEXT UintVar
      CLOSE FileHandler
  END SELECT
END SUB


SUB LoadHiScoresMem()
  'DIM AS UBYTE UbyteBuff1, UbyteBuff2
  DIM AS UINTEGER FileHandler, UintVar
  FileHandler = FREEFILE
  GetSaveDir()  ' provides the SaveDir variable
  SELECT CASE RomInfos.CrcSum
    CASE &h0509069C, &hB681E243  ' Pac-Man
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hFF8C TO &hFF8E
          GET #FileHandler,, MemoryInternalHiRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hFF89) = UintVar
        NEXT UintVar
        CLOSE FileHandler
      END IF
    CASE &hF59CEDEA  ' Pipe Dream
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hC212 TO &hC22C
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hC211) = UintVar
        NEXT UintVar
        CLOSE FileHandler
      END IF
    CASE &h2C27EC70, &h90776841  ' Super Marioland v1.1 and Super Marioland v1.0
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        'FOR UintVar = &hC0A0 TO &hC0A3
        '  GET #FileHandler,, MemoryInternalRAM(UintVar)
        'NEXT UintVar
        FOR UintVar = &hC0C0 TO &hC0C3
          GET #FileHandler,, MemoryInternalRAM(UintVar)
        NEXT UintVar
        SaveScoresWriteProtection(1) = &hC0A0
        SaveScoresWriteProtection(2) = &hC0A1
        SaveScoresWriteProtection(3) = &hC0A2
        SaveScoresWriteProtection(4) = &hC0A3
        SaveScoresWriteProtection(5) = &hC0C0
        SaveScoresWriteProtection(6) = &hC0C1
        SaveScoresWriteProtection(7) = &hC0C2
        SaveScoresWriteProtection(8) = &hC0C3
        CLOSE FileHandler
      END IF
  END SELECT
END SUB
