REM
REM LoadPalette()  -  Loads a color palette from an external file.
REM
REM This file is part of the zBoy project.
REM Copyright (C) Mateusz Viste 2010
REM


SUB LoadPalette(BYREF palfile AS STRING)
  DIM AS INTEGER FileHandler, OpenResult
  DIM AS STRING TempLine
  DIM AS UBYTE Rvalue, Gvalue, Bvalue, x
  IF FileExists(palfile) = 0 THEN ' file not found
      PrintMsg("ERROR: THE SPECIFIED PALETTE FILE COULD NOT BE FOUND!" + CHR(10,10) + "PRESS ANY KEY TO QUIT...")
      PressAnyKey()
      END
    ELSE
      FileHandler = FREEFILE
      OpenResult = OPEN(palfile, FOR INPUT, AS #FileHandler)
      IF (OpenResult = 0) THEN  ' File opened okay
          LINE INPUT #FileHandler, TempLine
          IF (TempLine = "JASC-PAL") THEN
              LINE INPUT #FileHandler, TempLine  ' Version
              IF (TRIM(TempLine) = "0100") THEN ' check the version
                  LINE INPUT #FileHandler, TempLine  ' Number of colors
                  IF (VAL(TempLine) = 16) THEN ' check the number of colors in the palette
                      FOR x = 0 TO 15
                        LINE INPUT #FileHandler, TempLine ' get the color definition
                        Rvalue = VAL(LEFT(TempLine, INSTR(TempLine, " ") - 1))
                        TempLine = MID(TempLine, INSTR(TempLine, " ") + 1)
                        Gvalue = VAL(LEFT(TempLine, INSTR(TempLine, " ") - 1))
                        TempLine = MID(TempLine, INSTR(TempLine, " ") + 1)
                        Bvalue = VAL(TempLine)
                        REM * Load 32BPP palette *
                        ScreenPalette32(x) = RGB(Rvalue, Gvalue, Bvalue)
                        REM * Load 16BPP palette *
                        Rvalue = (Rvalue AND &b11111000) SHR 3
                        Gvalue = (Gvalue AND &b11111100) SHR 2
                        Bvalue = (Bvalue AND &b11111000) SHR 3
                        ScreenPalette16(x) = (Rvalue SHL 11) OR (Gvalue SHL 5) OR (Bvalue)
                      NEXT x
                      CLOSE #FileHandler
                    ELSE ' Invalid number of colors
                      PrintMsg("ERROR: THE PALETTE FILE CONTAINS AN UNSUPPORTED NUMBER OF COLORS!" + CHR(10,10) + "ZBOY SUPPORTS ONLY JASC PALETTES WITH 16 COLORS." + CHR(10,10) + "PRESS ANY KEY TO QUIT...")
                      CLOSE #FileHandler
                      PressAnyKey()
                      END
                  END IF
                ELSE ' Unknown palette version
                  PrintMsg("ERROR: THE SPECIFIED PALETTE FILE VERSION IS NOT SUPPORTED!" + CHR(10,10) + "ZBOY SUPPORTS ONLY JASC PALETTES IN VERSION 0100." + CHR(10,10) + "PRESS ANY KEY TO QUIT...")
                  CLOSE #FileHandler
                  PressAnyKey()
                  END
              END IF
            ELSE
              PrintMsg("ERROR: THE SPECIFIED PALETTE FILE IS NOT A VALID JASC PALETTE!" + CHR(10,10) + "PRESS ANY KEY TO QUIT...")
              CLOSE #FileHandler
              PressAnyKey()
              END
          END IF
        ELSE
          PrintMsg("ERROR: THE SPECIFIED PALETTE FILE COULD NOT BE OPENED FOR SOME UNKNOWN REASONS." + CHR(10,10) + "PRESS ANY KEY TO QUIT...")
          PressAnyKey()
          END
      END IF
  END IF
END SUB
